<?php
/**
 * Yii uploader
 *
 * @author Marc Oliveras Galvez <oligalma@gmail.com> 
 * @link http://www.oligalma.com
 * @copyright 2016 Oligalma
 * @license New BSD License
 */
?>
<h1 class="center">Yii uploader</h1>
<div class="center margin-bottom-20">
<?php
Yii::app()->clientScript->registerScript('foldersjs',"
    $('#folder').change(function(){
        $('#selector-form').submit();
    });
");
$form=$this->beginWidget('CActiveForm', array(
    'id'=>'selector-form',
    'enableClientValidation'=>false,
    'action'=>Yii::app()->createUrl('uploader/image/index'),
)); 

echo CHtml::dropDownList('folder',$folder, $folders);    
?>
&nbsp;&nbsp;
<?php
$this->endWidget();
?>
</div>
<?php
$form=$this->beginWidget('CActiveForm', array(
    'id'=>'image-uploader-form',
    'enableClientValidation'=>false,
    'action'=>Yii::app()->createUrl('uploader/image/update'),
    'htmlOptions' => array('enctype' => 'multipart/form-data')
)); 
?>
    <input type="hidden" name="action">
    <table id="images_table">
        <thead>
        <tr>
            <th>
                Image<br/>(Click to enlarge)
            </th>
            <th>
                Name
            </th>
            <th>
                Description
            </th>
            <th>
                Select image
            </th>
            <th>
                Delete
            </th>
            <th>
                <a target="_blank" title="Uploader developed by Oligalma" href="http://oligalma.com"><b>?</b></a>
            </th>
        </tr>
        </thead>
        <tbody id="sortable">
        <?php
        $codesarray = array();
        foreach($images as $image):
            $codesarray[] = $image->id;
        ?>
            <tr <?= (count($codesarray) % 2 == 0 ? 'class="even"' : '') ?>>
                <td>
                    <a data-overlay-trigger="overlay" href="#" rel="prettyPhoto" ><img src="<?= Yii::app()->baseUrl . '/images/' . $folder . '/'  . $image->file ?>" /></a>
                </td>
                <td>
                    <input type="text" name="name<?= $image->id ?>" value="<?= $image->name ?>" />
                </td>
                <td>
                    <input type="text" name="description<?= $image->id ?>" value="<?= $image->description ?>" />
                </td>
                <td>
                    <input type="file" name="image<?= $image->id ?>" />
                </td>
                <td>
                    <input type="checkbox" name="delete<?= $image->id ?>" />
                </td>
                <td>
                    <input class="sortable-item" type="hidden" name="ordering<?= $image->id ?>" value="<?= $image->ordering ?>" />
                    <span class="ui-icon ui-icon-arrowthick-2-n-s"></span>
                </td>
            </tr>
            <?php
            endforeach;
            ?>
            <tr <?= ((count($codesarray) + 1) % 2 == 0 ? 'class="even"' : '') ?>>
                <td>
                </td>
                <td>
                    <input type="text" name="name<?= $nextId ?>" />                 
                </td>
                <td>
                    <input type="text" name="description<?= $nextId ?>" />
                </td>
                <td>
                    <input type="file" name="image<?= $nextId ?>" />
                </td>
                <td>
    
                </td>
                <td>
                    <input class="sortable-item" type="hidden" name="ordering<?= $nextId ?>" value="0" />
                    <span class="ui-icon ui-icon-arrowthick-2-n-s"></span>
                </td>
            </tr>
        </tbody>
    </table>
    <div id="submit-button">
        <?= CHtml::submitButton('Save') ?>
    </div>
<?php
        echo CHtml::hiddenField('folder', $folder);
        
    $this->endWidget();
?>
<div class="overlay" id="overlay">
  <div class="modal">
    <img src="" />
  </div>
</div>
<?php
Yii::app()->clientScript->registerCss('uploadercss','
    #content
    {
        padding:5px;
    }

    @media all and (max-width: 850px)
    {
        #images_table td:nth-of-type(1):before { content: "Image"; }
        #images_table td:nth-of-type(2):before { content: "Name"; }
        #images_table td:nth-of-type(3):before { content: "Description"; }
        #images_table td:nth-of-type(4):before { content: "Select image"; }
        #images_table td:nth-of-type(5):before { content: "Delete"; }
    }
');
Yii::app()->clientScript->registerCssFile($this->module->assetsUrl . '/css/uploader.css');
Yii::app()->clientScript->registerCssFile($this->module->assetsUrl . '/js/jquery-ui-1.11.4.custom/jquery-ui.min.css');
Yii::app()->clientScript->registerScriptFile($this->module->assetsUrl . '/js/uploader.js', CClientScript::POS_END);
Yii::app()->clientScript->registerScriptFile($this->module->assetsUrl . '/js/jquery-ui-1.11.4.custom/jquery-ui.min.js', CClientScript::POS_END);
Yii::app()->clientScript->registerScript('uploaderjs',
'
    var maxcode = ' . $nextId . ';
    var filename = \'\';
    var codesarray = ' . json_encode($codesarray) . ';
    var numrows = ' . count($codesarray) . ';

    $("form").on(\'focus\', \'input[type="file"]\', function () {
        filename = $(this).val();
    });
    
    $("form").on(\'change\', \'input[type="file"]\', function(){
        var str = $(this).attr(\'name\');
        var res = str.substring(6);
        if (filename == \'\' && $.inArray(res,codesarray) == -1) {        
            maxcode++;
            $(\'#images_table\').append(\'<tr \' + (numrows % 2 == 0 ?\'class="even"\':\'\') + \'><td></td><td><input type="text" name="name\' + maxcode + \'" /></td><td><input type="text" name="description\' + maxcode + \'" /></td><td><input type="file" name="image\' + maxcode + \'" /></td><td></td><td><input class="sortable-item" type="hidden" name="ordering\' + maxcode + \'" value="0" /><span class="ui-icon ui-icon-arrowthick-2-n-s"></span></td></tr>\');
            numrows++;
            reorder();
        }
        newfile = false;
    });
    
  $(function(){
    $("#sortable").sortable(
        {
            axis: "y",
            stop: function(event, ui) {
                reorder();
            }
        }
    );
  });
  
  function reorder()
  {
        i = 1;
        $(".sortable-item").each(function(){
            $(this).val(i);
            i++;
        })
  }
');
?>